//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
 {
 }
//---------------------------------------------------------------------------

void __fastcall TForm1::AngleTextOut(TCanvas *CV, String sText, int x, int y, int angle)
 {
 LOGFONT lgfont;
 TFont *SaveFont = new TFont;

 SaveFont->Assign(CV->Font);
 GetObject(SaveFont->Handle, sizeof(lgfont), &lgfont);
 // Modification  notre guise de l'orientation de la la fonte
 lgfont.lfEscapement = angle * 10;
 lgfont.lfPitchAndFamily = FIXED_PITCH | FF_DONTCARE;
 // Cration de la fonte par CreateFontIndirect en se basant sur la structure
 // LogFont et assignation  la fonte du canvas
 CV->Font->Handle = CreateFontIndirect(&lgfont);
 SetBkMode(CV->Font->Handle, TRANSPARENT);
 // Ecriture du texte avec l'inclinaison voulue
 CV->TextOut(x, y, sText);
 CV->Font->Assign(SaveFont);
 SaveFont->Free();
 }
//---------------------------------------------------------------------------

void __fastcall TForm1::ListerClick(TObject *Sender)
 {
 Imprimantes->Clear();
 // Lister les imprimantes installees
 Imprimantes->Items = Printer()->Printers;
 // selectionner l'imprimante par default definie dans Windows
 Imprimantes->ItemIndex = Printer()->PrinterIndex;
 }
//---------------------------------------------------------------------------

void __fastcall TForm1::ImprimanteClick(TObject *Sender)
 {
 Imprimantes->Clear();
 Imprimantes->Items->Add(Printer()->Printers->Strings[Printer()->PrinterIndex]);
 }
//---------------------------------------------------------------------------

void __fastcall TForm1::Episode1Click(TObject *Sender)
 {
 String S;

 TPrinter *Prnt = Printer();
 // Demarrage de l'impression
 Prnt->BeginDoc();
 // Trace de la zone imprimable
 Prnt->Canvas->Rectangle(0, 0, Prnt->PageWidth, Prnt->PageHeight);
 // Dans chaque coin de la feuille, nous allons ecrire le texte "C++ Builder c'est super"
 S = "C++ Builder c'est super";
 // Augmentons la taille de la fonte pour une meilleur visibilite
 Prnt->Canvas->Font->Size = 12;
 // En haut a gauche
 Prnt->Canvas->TextOutA(0, 0, S);
 // En haut a droite
 Prnt->Canvas->TextOutA(Prnt->PageWidth - Prnt->Canvas->TextWidth(S), 0, S);
 // En bas a gauche
 Prnt->Canvas->TextOutA(0, Prnt->PageHeight - Prnt->Canvas->TextHeight(S), S);
 // En bas a droite
 Prnt->Canvas->TextOutA(Prnt->PageWidth - Prnt->Canvas->TextWidth(S), Prnt->PageHeight - Prnt->Canvas->TextHeight(S), S);
 // Enfin, au centre de la feuille
 Prnt->Canvas->TextOutA(int((Prnt->PageWidth - Prnt->Canvas->TextWidth(S)) / 2), int((Prnt->PageHeight - Prnt->Canvas->TextHeight(S)) / 2), S);
 // Envoie des commandes  l'imprimante
 Prnt->EndDoc();
 }
//---------------------------------------------------------------------------
 
void __fastcall TForm1::Episode2Click(TObject *Sender)
 {
 HWND hdc;

 // On place dans une variable le handle de l'imprimante
 hdc = Printer()->Handle;
 Details->Clear();
 //La constante HORZSIZE nous fournit la largeur en millimtres
 Details->Lines->Add("Largeur zone imprimable en mm: " + IntToStr(GetDeviceCaps(hdc, HORZSIZE)));
 //La constante VERTSIZE nous fournit la hauteur en millimtres
 Details->Lines->Add("Hauteur zone imprimable en mm: " + IntToStr(GetDeviceCaps(hdc, VERTSIZE)));
 //La constante HORZRES nous fournit la largeur en pixels
 Details->Lines->Add("Largeur zone imprimable en pixels: " + IntToStr(GetDeviceCaps(hdc, HORZRES)));
 //La constante VERTRES nous fournit la hauteur en pixels
 Details->Lines->Add("Hauteur zone imprimable en pixels: " + IntToStr(GetDeviceCaps(hdc, VERTRES)));

 // Vous pouvez voir ici qu'il est maintenant facile de calculer le rapport entre  les pixels
 // et les millimtres sur votre page imprime 1 pixel horizontal imprimante =
 // GetDeviceCaps(hdc, HORZSIZE) / GetDeviceCaps(hdc, HORZRES)

 // La constante PHYSICALOFFSETX nous fournit la taille en pixels de la zone
 // non imprimable  partir du bord gauche de la feuille
 Details->Lines->Add("pixels non imprimables  gauche: " + IntToStr(GetDeviceCaps(hdc, PHYSICALOFFSETX)));

 // La constante PHYSICALOFFSETY nous fournit la taille en pixels de la zone
 // non imprimable  partir du bord haut de la feuille
 Details->Lines->Add("pixels non imprimables en haut: " + IntToStr(GetDeviceCaps(hdc, PHYSICALOFFSETY)));

 // rajouter dans la dclaration des variables de la fonction
 String S;
 TRect R;
 //notre prcdent code ...............
 R.left = 10;
 R.top = 10;
 S = "Calcul rectangle avec DrawText";
 DrawText(Printer()->Handle, S.c_str(), S.Length(), &R, DT_CALCRECT);
 Details->Lines->Add("Largeur / Hauteur ; " + IntToStr(R.right) + " / " + IntToStr(R.Bottom));
 //Rajoutons un saut de ligne pour voir la diffrence
 S = "Calcul rectangle \r\n avec DrawText";
 DrawText(Printer()->Handle, S.c_str(), S.Length(), &R, DT_CALCRECT);
 Details->Lines->Add("Largeur / Hauteur ; " + IntToStr(R.right) + " / " + IntToStr(R.Bottom));
 }
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
 {
 HWND hdc;
 TRect R;

 Image1->Picture = NULL; // on efface TImage1
 hdc = Image1->Canvas->Handle;
 R = Image1->ClientRect;

 String chaine0 = "NORD";
 String chaine1 = "CENTRE";
 String chaine2 = "SUD";
 String chaine3 = "NORD_OUEST";
 String chaine4 = "OUEST";
 String chaine5 = "SUD_OUEST";
 String chaine6 = "NORD_EST";
 String chaine7 = "EST";
 String chaine8 = "SUD_EST";
 
 DrawText(hdc, chaine0.c_str(), chaine0.Length(), &R, DT_TOP | DT_CENTER | DT_SINGLELINE);
 DrawText(hdc, chaine1.c_str(), chaine1.Length(), &R, DT_VCENTER | DT_CENTER | DT_SINGLELINE);
 DrawText(hdc, chaine2.c_str(), chaine2.Length(), &R, DT_BOTTOM | DT_CENTER | DT_SINGLELINE);
 DrawText(hdc, chaine3.c_str(), chaine3.Length(), &R, DT_TOP | DT_LEFT | DT_SINGLELINE);
 DrawText(hdc, chaine4.c_str(), chaine4.Length(), &R, DT_VCENTER | DT_LEFT | DT_SINGLELINE);
 DrawText(hdc, chaine5.c_str(), chaine5.Length(), &R, DT_BOTTOM | DT_LEFT | DT_SINGLELINE);
 DrawText(hdc, chaine6.c_str(), chaine6.Length(), &R, DT_TOP | DT_RIGHT | DT_SINGLELINE);
 DrawText(hdc, chaine7.c_str(), chaine7.Length(), &R, DT_VCENTER | DT_RIGHT | DT_SINGLELINE);
 DrawText(hdc, chaine8.c_str(), chaine8.Length(), &R, DT_BOTTOM | DT_RIGHT | DT_SINGLELINE);

 Image1->Canvas->Font->Name = "Times New Roman";
 AngleTextOut(Image1->Canvas, "INCLINE", int(Image1->Width / 4), int(Image1->Height / 2), 45);
 Image1->Repaint();
 }
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
 {
 int XCols[4];
 String S;
  int I, Y, H;

 Image1->Picture = NULL; // on efface TImage1
 XCols[0] = 0;
 XCols[1] = int(Image1->Width / 4);
 XCols[2] = int(Image1->Width / 2);
 XCols[3] = Image1->Width - XCols[1];
 
 Y = 0;

 H = Image1->Canvas->TextHeight("M"); // la plus haute
 
 for (I = 0; I <+5; I++)
 {
 S = ("L" + IntToStr(I) + "C0 \t L" + IntToStr(I) + "C1 \t L" + IntToStr(I) + "C2 \t L" + IntToStr(I) + "C3");
 TabbedTextOut(Image1->Canvas->Handle, 0, Y, S.c_str(), S.Length(), 4, &XCols[1], 0);
 Y = Y + H + 2;
 }
 Image1->Repaint();
 }
//---------------------------------------------------------------------------


