//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Printers.hpp"

#include <vector>
using namespace std;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

 // Base de donnee utilisee BCDEMOS <-------
 // Table utilisee country.db       <-------

 TRect Entete ;
 TRect Details ;
 TRect PiedPage;        // pour connatre les limites des zones respectives
 int YCurr;             // La position en cours pour l'criture d'une ligne
 int Li;                // nombre de lignes imprimes
 int Dx;
 int Dy;                // Dcalage par rapport aux marges
 int unsigned short NPage = 0;          // Le numro de page  incrmenter  chaque nouvelle page
 int unsigned short TotalPages = 0;     // Le nombre de pages  imprimer. Pour afficher Page x / TotalPages
 int resultX;
 int resultY;
 AnsiString S;
 vector<int> T;         // Dclaration du tableau dynamique

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
 {
 }
//---------------------------------------------------------------------------
void __fastcall TForm1::Millimetres2PixelsX(int Millims)
 {
 resultX = MulDiv(GetDeviceCaps(Printer()->Handle, LOGPIXELSX), 10 * Millims, 254);
 }
//---------------------------------------------------------------------------
void __fastcall TForm1::Millimetres2PixelsY(int Millims)
 {
 resultY = MulDiv(GetDeviceCaps(Printer()->Handle, LOGPIXELSY), 10 * Millims, 254);
 }
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
 {
 int HM;
 TBookmark Bm;
 bool Bl;
 Word LignesParPage;

 Li = 0;                 // initialisation du nombre de lignes imprime
 Millimetres2PixelsX(2); // Calcul en pixels d'un dcalage haut et bas de 2 mm
 Dx = resultX;           // en cas d'impression texte prs des marges
 Millimetres2PixelsY(2);
 Dy = resultY;

 Printer()->Orientation = poLandscape;
 Printer()->BeginDoc();

 // Hauteur de l'entte = 10% de la hauteur totale
 Entete = Rect(0, 0, Printer()->PageWidth, MulDiv(Printer()->PageHeight, 10, 100));

 // Hauteur du pied de page = 5% de la hauteur totale
 PiedPage = Rect(0, Printer()->PageHeight - MulDiv (Printer()->PageHeight, 5, 100), Printer()->PageWidth, Printer()->PageHeight);

 Details.Left = 0;
 Details.Right = Printer()->PageWidth;

 // Haut de la zone dtails  10 mm sous le bas de l'en-tte
 Millimetres2PixelsY(10);
 Details.Top = Entete.bottom + resultY;

 // Bas de la zone dtails  5 mm au-dessus du haut du pied de page
 Millimetres2PixelsY(5);
 Details.Bottom = PiedPage.Top - resultY;

 // Calcul du nombre de ligne par page, et ainsi du nombre de page
 DefFonte(Printer()->Canvas->Font, "Arial", 11, TFontStyles());
 HM = Printer()->Canvas->TextHeight("M");     // On calcule la hauteur d une ligne en pixels

 // On peut ainsi calculer le nombre de lignes que peut contenir la zone Details
 LignesParPage = (Details.Bottom - Details.Top - Dy) / HM;

 // Le nombre de pages sera calcul en divisant le nombre total de lignes par LignesParPage
 TotalPages = Datas->RecordCount / LignesParPage;

 // ATTENTION: on doit galement vrifier si les pages seront compltes.
 // Avec mod on peut voir s'il nous restera des lignes  imprimer en fin de document
 Bl = ((Datas->RecordCount) % (LignesParPage)) != 0;

 // Si on obtient un reste, il nout faut ajouter une page
 if(Bl)
  {
   TotalPages++;
  }

 // Prenons un exemple! Si la zone Details peut contenir 35 lignes et si nous avons
 // 42 lignes  imprimer, nous aurons les valeurs suivantes:
 // TotalPages := 42 div 35; Donc  TotalPages  =  1 (1 page de 35 lignes)
 // Bl = (42 mod 35) <> 0 ;  Donc  true puisque 42 mod 35 = 7.
 // Ainsi, nous avons dfini que nous aurons 1 page complte de 35 lignes et une page
 // incomplte de 7 lignes
 // Utilisons le nombre de colonnes de la DBGrid pour dfinir nos colonnes sur la sortie imprime
 // Bien sur, cela n'est valable que si vous avez un nombre raisonnable de colonnes.
 // La table utilise dans l'exemple s'y prte bien.
 // Dans un autre cas, vous serez oblig de dfinir quelles colonnes vous voulez imprimer

 // Dfinition de sa taille
 int t = DBGrid1->Columns->Count;

 DefiniColonnes(t);

 NPage = 0;

 // Le paramtre de NouvellePage est false, car la page est dj cre par BeginDoc
 NouvellePage(false);

 Bm = Datas->GetBookmark();
 Datas->DisableControls();
 Datas->First();
 DefFonte(Printer()->Canvas->Font, "Arial", 11, TFontStyles());
 while(!Datas->Eof)
 {
 Datas->Next();
 // Utilisation d'une procdure pour construire la chane  utiliser avec TabbedTextOut
 DefLigne();

 //  chaque ligne on incrmente le nombre de lignes imprimes (pour le bas de page)
 Li++;
 TabbedTextOut(Printer()->Canvas->Handle, Dx, YCurr, S.c_str(), S.Length(), T.back(), &T[1], 0);

 // aprs impression de la ligne en cours, on passe  la ligne suivante next;
 // Ici, nous allons grer la ncessit de changer de page. yCurr est notre position
 // d'impression courante sur notre page.
 // Puisque nous connaissons la hauteur d'une ligne, nous allons incrmenter yCurr
 // de cette hauteur pour dfinir la valeur suivante en y
 YCurr = YCurr + HM;

 // Ici, nous devons vrifier si yCurr est toujours  l'intrieur de la zone Details,
 // et surtout si la place est suffisante pour imprimer une ligne
 if(YCurr >= (Details.bottom - HM))
  {
   ImprimePiedPage();
   NouvellePage(true);
  }
 }
 // Enfin, si le nombre de lignes ne correspondait pas  des pages compltes,
 // il faudrait imprimer le bas de page. On est oblig d'imprimer le pied de
 // page seulement quand une page de dtails a t cre pour connaitre le nombre
 // de lignes dj imprimes. Dans un autre cas, ImprimerPiedPage pourrait tre
 // ajout  la procdure NouvellePage
 if(Bl)
  {
   ImprimePiedPage();
  }

 Datas->GotoBookmark(Bm);
 Datas->FreeBookmark(Bm);
 Datas->EnableControls();

 Printer()->EndDoc();
 }
//---------------------------------------------------------------------------
void __fastcall TForm1::DefFonte(TFont *F, String Nom, int Taille, TFontStyles Styl)
 {
 F->Name = Nom;
 F->Size = Taille;
 F->Style = Styl;
 }
//---------------------------------------------------------------------------
void __fastcall TForm1::ImprimeEnTete()
 {
 String S;

 // On dessine l'entourage (si on le dsire)
 Printer()->Canvas->Rectangle(Entete);
 DefFonte(Printer()->Canvas->Font, "Arial", 10, TFontStyles());

 // Ecriture de la date en haut  gauche en n'oubliant pas les
 // dcalages par rapport aux marges
 // Vous remarquerez que l'on aurait aussi pu utiliser DrawText avec DT_LEFT or DT_VTOP
 Printer()->Canvas->TextOut(Entete.Left + Dx, Entete.Top + Dy, DateToStr(Date()));

 // Notre page en cours
 S = ("Page" + IntToStr(NPage) + " / " + IntToStr(TotalPages));
 Printer()->Canvas->TextOut(Entete.Right - Printer()->Canvas->TextWidth(S) - Dx, Entete.top + Dy, S);

 // Enfin, centr au milieu de notre rectangle d'en-tte le nom de la table
 DefFonte(Printer()->Canvas->Font, "Times New Roman", 24, TFontStyles());
 DrawText(Printer()->Canvas->Handle, (Datas->TableName).c_str(), (Datas->TableName).Length(), &Entete,  DT_VCENTER | DT_SINGLELINE | DT_CENTER);

 // On dessine si on le dsire un entourage autour de la zone Dtails
 Printer()->Canvas->Rectangle(Details);
 }
//---------------------------------------------------------------------------
void __fastcall TForm1::ImprimePiedPage()
 {
 String S;
 Printer()->Canvas->Rectangle(PiedPage);
 DefFonte(Printer()->Canvas->Font, "Arial", 10, TFontStyles());
 S = (IntToStr(Li) + "lignes imprimes sur un total de "  + IntToStr(Datas->RecordCount));
 DrawText(Printer()->Canvas->Handle, S.c_str(), S.Length(), &PiedPage, DT_VCENTER | DT_SINGLELINE | DT_CENTER);
 }
//---------------------------------------------------------------------------
void __fastcall TForm1::NouvellePage(bool RealNewPage)
 {
 if(RealNewPage)
  {
   Printer()->NewPage();
  }
 NPage++;
 ImprimeEnTete();
 YCurr = Details.Top + Dy;
 }
//---------------------------------------------------------------------------
void __fastcall TForm1::DefiniColonnes(int Tb)
 {
 int I;
 int J;
 int L;
 long double tabu = 0;
 long double lrg_cols = 0;
 long double lrg;

 L = Details.Right - Details.Left;
 lrg = Width;
 T.resize(Tb);
 T[0] = 0;
 for(I = 0; I < Tb; I++)
  {
   long double lrg_col = DBGrid1->Columns->Items[I]->Width;
   lrg_cols = lrg_cols + lrg_col;
   long double rapport_lrg = lrg_col / lrg;
   tabu =  tabu + (L * rapport_lrg);
   T[I + 1] = tabu;
  }

 long double coef = lrg_cols / lrg;
 for(I = 1; I < Tb; I++)
  {
   T[I] = T[I] / coef;
  }
 }
//---------------------------------------------------------------------------
void __fastcall TForm1::DefLigne()
 {
 int I;
 String s = "";
 for(I = 0; I <= Datas->Fields->Count - 1;I++)
  {
   s = s + Datas->Fields->Fields[I]->AsString + "\t";
  }
 S = s.SetLength(s.Length() - 1);// Pour supprimer le dernier caractre de tabulation
 }
//---------------------------------------------------------------------------
