//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Printers.hpp"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
 TMetafile *pMetafile;
 TMetafileCanvas *pCanvas;
 TList *LPages = new TList();
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
 {
 }
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
 {
 TRect R;
 String S;
 int P;

 P = GetDeviceCaps(Printer()->Handle, LOGPIXELSX);

 for(int I = 0; I <=2; I++)
  {
   pMetafile = new TMetafile;
   pMetafile->Width = Printer()->PageWidth;
   pMetafile->Height = Printer()->PageHeight;
   LPages->Add(pMetafile);
  }

 pCanvas = new TMetafileCanvas((TMetafile *)LPages->Items[0], 0);
 // ecriture d'une premiere chaine
 pCanvas->Font->PixelsPerInch = P;
 pCanvas->Font->Size = 18;
 pCanvas->TextOut(10, 10, "Vous etes sur la page 1");
 // ecriture d'une seconde chaine
 pCanvas->Font->Size = 22;
 S = "Ce texte est centre sur la page";
 R = Rect(0, 0, Printer()->PageWidth, Printer()->PageHeight);
 DrawText(pCanvas->Handle, S.c_str(),S.Length(), &R, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
 delete pCanvas;

 pCanvas = new TMetafileCanvas((TMetafile *)LPages->Items[1], 0);
 InflateRect(&R, -300, -300);
 pCanvas->Ellipse(R);
 pCanvas->Pen->Color = clBlue;
 InflateRect(&R, -200, -200);
 pCanvas->Ellipse(R);
 pCanvas->Pen->Color = clGreen;
 InflateRect(&R, -200, -200);
 pCanvas->Ellipse(R);
 pCanvas->Pen->Color = clRed;
 InflateRect(&R, -200, -200);
 pCanvas->Ellipse(R);
 InflateRect(&R, -200, -200);
 pCanvas->Rectangle(R);
 delete pCanvas;

 HDC I;
 I = GetDC(0); // Obtention d'un handle de device context sur l'cran
 pCanvas = new TMetafileCanvas((TMetafile *)LPages->Items[2], 0);
 StretchBlt(pCanvas->Handle, 0, 0,
             Printer()->PageWidth, Printer()->PageHeight,
             I, 0, 0,
             Screen->Width, Screen->Height,
             SRCCOPY);
 ReleaseDC(Handle, I); // ne pas oublier de relcher le HDC
 Prv->Tag = 0;
 delete pCanvas;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ImprimerClick(TObject *Sender)
{
 // imprimer
 Printer()->BeginDoc();
 Printer()->Canvas->Draw(0, 0, (TMetafile *)LPages->Items[0]);
 Prv->Tag = 0;
 Prv->Refresh();
 Sleep(1000);
 Printer()->NewPage();
 Printer()->Canvas->Draw(0, 0, (TMetafile *)LPages->Items[1]);
 Prv->Tag = 1;
 Prv->Refresh();
 Sleep(1000);
 Printer()->NewPage();
 Printer()->Canvas->Draw(0, 0, (TMetafile *)LPages->Items[2]);
 Prv->Tag = 2;
 Prv->Refresh();
 Sleep(1000);
 Printer()->EndDoc();
 }
//---------------------------------------------------------------------------

void __fastcall TForm1::PrvPaint(TObject *Sender)
 {
 if(LPages->Count > 0)
  {
   Prv->Canvas->Brush->Color = clWhite;
   pMetafile = (TMetafile *)LPages->Items[Prv->Tag];
   Prv->Canvas->FillRect(Rect(0,0, pMetafile->Width, pMetafile->Height)); //Pour "peindre" le fond en blanc.
   Prv->Canvas->StretchDraw(Rect(0, 0, Prv->Width, Prv->Height), pMetafile);
  }
 }
//---------------------------------------------------------------------------

void __fastcall TForm1::AvantClick(TObject *Sender)
 {
 // avant
 if(Prv->Tag > 0)
  {
   Prv->Tag = Prv->Tag - 1;
   Prv->Refresh();
  }
 else
  {
   Prv->Refresh();
   ShowMessage(" Vos tes sur la premire page visible ");
  }
 }
//---------------------------------------------------------------------------

void __fastcall TForm1::ApresClick(TObject *Sender)
{
 // apres
 if(Prv->Tag < LPages->Count - 1)
  {
   Prv->Tag = Prv->Tag + 1;
   Prv->Refresh();
  }
 else
  {
   Prv->Refresh();
   ShowMessage(" Vos tes sur la dernire page visible ");
  }
 }
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
 {
 for(int i = 0; i <= LPages->Count - 1; i++)
  {
   delete (TMetafile *)LPages->Items[i];
  }
 LPages->Clear();
 delete LPages;
 }
//---------------------------------------------------------------------------

